import 'package:flutter/material.dart';
import 'package:google_fonts/google_fonts.dart';

class VgkprogamingTheme {
  VgkprogamingTheme._();
  static int milliseconds = 700;

  static Color primaryColor = HexColor('#00b4ab');
  static Color secondayColor = HexColor('#0090b4');

  static Color primaryColorDark = HexColor('#00b4ab');
  static Color secondayColorDark = HexColor('#0090b4');

  static Color primaryColorFont = Colors.black;
  static Color secondaryColorFont = Colors.white;

  static Color boxBackground = HexColor('#e1e4e6');
  static Color boxBackgroundWithOpacity =
      VgkprogamingTheme.boxBackground.withOpacity(0.6);
  static Color background = Color(0xFFF2F3F8);

  static Color grey = Color(0xFF3A5160);
  static Color greyWithOpacityLow = VgkprogamingTheme.grey.withOpacity(0.2);
  static Color greyWithOpacityMedium = VgkprogamingTheme.grey.withOpacity(0.5);
  static Color greyWithOpacityHigh = VgkprogamingTheme.grey.withOpacity(0.4);

  static Color lightGrey = HexColor('#e1e4e6');
  static Color lightGreyWithOpacityLow = HexColor('#e1e4e6').withOpacity(0.3);
  static Color lightGreyWithOpacityMedium =
      HexColor('#e1e4e6').withOpacity(0.6);
  static Color lightGreyWithOpacityHigh = HexColor('#e1e4e6').withOpacity(0.9);

  static Color notWhite = Color(0xFFEDF0F2);
  static Color white = Color(0xFFFFFFFF);
  static Color darkGrey = Color(0xFF313A44);

  static Color nearlyBlue = Color(0xFF00B6F0);
  static Color nearlyDarkBlue = Color(0xFF2633C5);
  static Color nearlyBlack = Color(0xFF213333);
  static Color nearlyWhite = Color(0xFFFEFEFE);

  static Color darkText = Color(0xFF253840);
  static Color lightText = Color(0xFF4A6572);
  static Color deactivatedText = Color(0xFF767676);
  static Color dismissibleBackground = Color(0xFF364A54);
  static Color spacer = Color(0xFFF2F2F2);

  static const double letterSpacing = 0.27;
  static const double heightSpace = 4;

  static const double fontSizeTripleExtraSmall = 6;
  static const double fontSizeDoubleExtraSmall = 8;
  static const double fontSizeExtraSmall = 10;
  static const double fontSizeSmall = 12;
  static const double fontSizeMedium = 14;
  static const double fontSizeLarge = 16;
  static const double fontSizeExtraLarge = 18;
  static const double fontSizeDoubleExtraLarge = 20;
  static const double fontSizeTripleExtraLarge = 22;

  static FontWeight fontWeightDoubleExtraSmall = FontWeight.w100;
  static FontWeight fontWeightExtraSmall = FontWeight.w200;
  static FontWeight fontWeightSmall = FontWeight.w300;
  static FontWeight fontWeightMedium = FontWeight.w400;
  static FontWeight fontWeightLarge = FontWeight.w500;
  static FontWeight fontWeightExtraLarge = FontWeight.w600;
  static FontWeight fontWeightDoubleExtraLarge = FontWeight.w700;
  static FontWeight fontWeightTripleExtraLarge = FontWeight.w700;

  static const double paddingTripleExtraSmall = 2;
  static const double paddingDoubleExtraSmall = 4;
  static const double paddingExtraSmall = 6;
  static const double paddingSmall = 8;
  static const double paddingMedium = 10;
  static const double paddingLarge = 12;
  static const double paddingExtraLarge = 14;
  static const double paddingDoubleExtraLarge = 16;
  static const double paddingTripleExtraLarge = 24;

  static TextStyle h1 = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightExtraLarge,
    fontSize: VgkprogamingTheme.fontSizeExtraLarge,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.primaryColor,
  );

  static TextStyle h2 = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightLarge,
    fontSize: VgkprogamingTheme.fontSizeLarge,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.primaryColor,
  );

  static TextStyle h3 = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightMedium,
    fontSize: VgkprogamingTheme.fontSizeMedium,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.primaryColor,
  );

  static TextStyle h4 = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightSmall,
    fontSize: VgkprogamingTheme.fontSizeSmall,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.primaryColor,
  );

  static TextStyle h5 = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightExtraSmall,
    fontSize: VgkprogamingTheme.fontSizeExtraSmall,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.primaryColor,
  );

  static TextStyle h6 = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightDoubleExtraSmall,
    fontSize: VgkprogamingTheme.fontSizeDoubleExtraSmall,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.primaryColor,
  );

  static TextStyle h1White = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightExtraLarge,
    fontSize: VgkprogamingTheme.fontSizeExtraLarge,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.white,
  );

  static TextStyle h2White = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightLarge,
    fontSize: VgkprogamingTheme.fontSizeLarge,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.white,
  );

  static TextStyle h3White = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightMedium,
    fontSize: VgkprogamingTheme.fontSizeMedium,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.white,
  );

  static TextStyle h4White = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightSmall,
    fontSize: VgkprogamingTheme.fontSizeSmall,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.white,
  );

  static TextStyle h5White = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightExtraSmall,
    fontSize: VgkprogamingTheme.fontSizeExtraSmall,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.white,
  );

  static TextStyle h6White = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightDoubleExtraSmall,
    fontSize: VgkprogamingTheme.fontSizeDoubleExtraSmall,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.white,
  );

  static TextStyle h1Black = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightExtraLarge,
    fontSize: VgkprogamingTheme.fontSizeExtraLarge,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.white,
  );

  static TextStyle h2Black = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightLarge,
    fontSize: VgkprogamingTheme.fontSizeLarge,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.white,
  );

  static TextStyle h3Black = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightMedium,
    fontSize: VgkprogamingTheme.fontSizeMedium,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.white,
  );

  static TextStyle h4Black = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightSmall,
    fontSize: VgkprogamingTheme.fontSizeSmall,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.white,
  );

  static TextStyle h5Black = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightExtraSmall,
    fontSize: VgkprogamingTheme.fontSizeExtraSmall,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.white,
  );

  static TextStyle h6Black = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightDoubleExtraSmall,
    fontSize: VgkprogamingTheme.fontSizeDoubleExtraSmall,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.white,
  );

  static TextStyle h1WithOpacity = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightExtraLarge,
    fontSize: VgkprogamingTheme.fontSizeExtraLarge,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.primaryColor.withOpacity(0.5),
  );

  static TextStyle h2WithOpacity = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightLarge,
    fontSize: VgkprogamingTheme.fontSizeLarge,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.primaryColor.withOpacity(0.5),
  );

  static TextStyle h3WithOpacity = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightMedium,
    fontSize: VgkprogamingTheme.fontSizeMedium,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.primaryColor.withOpacity(0.5),
  );

  static TextStyle h4WithOpacity = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightSmall,
    fontSize: VgkprogamingTheme.fontSizeMedium,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.primaryColor.withOpacity(0.5),
  );

  static TextStyle h5WithOpacity = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightExtraSmall,
    fontSize: VgkprogamingTheme.fontSizeExtraSmall,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.primaryColor.withOpacity(0.5),
  );

  static TextStyle h6WithOpacity = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightDoubleExtraSmall,
    fontSize: VgkprogamingTheme.fontSizeDoubleExtraSmall,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: VgkprogamingTheme.primaryColor.withOpacity(0.5),
  );

  static TextStyle errorText = GoogleFonts.lato(
    fontWeight: VgkprogamingTheme.fontWeightLarge,
    fontSize: VgkprogamingTheme.fontSizeLarge,
    letterSpacing: VgkprogamingTheme.letterSpacing,
    color: Colors.red,
  );

  static EdgeInsets edgeInsetsPaddingTripleExtraSmall = EdgeInsets.only(
    top: VgkprogamingTheme.paddingTripleExtraSmall,
    bottom: VgkprogamingTheme.paddingTripleExtraSmall,
    right: VgkprogamingTheme.paddingTripleExtraSmall,
    left: VgkprogamingTheme.paddingTripleExtraSmall,
  );

  static EdgeInsets edgeInsetsPaddingDoubleExtraSmall = EdgeInsets.only(
    top: VgkprogamingTheme.paddingDoubleExtraSmall,
    bottom: VgkprogamingTheme.paddingDoubleExtraSmall,
    right: VgkprogamingTheme.paddingDoubleExtraSmall,
    left: VgkprogamingTheme.paddingDoubleExtraSmall,
  );

  static EdgeInsets edgeInsetsPaddingExtraSmall = EdgeInsets.only(
    top: VgkprogamingTheme.paddingExtraSmall,
    bottom: VgkprogamingTheme.paddingExtraSmall,
    right: VgkprogamingTheme.paddingExtraSmall,
    left: VgkprogamingTheme.paddingExtraSmall,
  );

  static EdgeInsets edgeInsetsPaddingSmall = EdgeInsets.only(
    top: VgkprogamingTheme.paddingSmall,
    bottom: VgkprogamingTheme.paddingSmall,
    right: VgkprogamingTheme.paddingSmall,
    left: VgkprogamingTheme.paddingSmall,
  );

  static EdgeInsets edgeInsetsPaddingMedium = EdgeInsets.only(
    top: VgkprogamingTheme.paddingMedium,
    bottom: VgkprogamingTheme.paddingMedium,
    right: VgkprogamingTheme.paddingMedium,
    left: VgkprogamingTheme.paddingMedium,
  );

  static EdgeInsets edgeInsetsPaddingLarge = EdgeInsets.only(
    top: VgkprogamingTheme.paddingLarge,
    bottom: VgkprogamingTheme.paddingLarge,
    right: VgkprogamingTheme.paddingLarge,
    left: VgkprogamingTheme.paddingLarge,
  );

  static EdgeInsets edgeInsetsPaddingDoubleExtraLarge = EdgeInsets.only(
    top: VgkprogamingTheme.paddingDoubleExtraLarge,
    bottom: VgkprogamingTheme.paddingDoubleExtraLarge,
    right: VgkprogamingTheme.paddingDoubleExtraLarge,
    left: VgkprogamingTheme.paddingDoubleExtraLarge,
  );

  static EdgeInsets edgeInsetsPaddingTripleExtraLarge = EdgeInsets.only(
    top: VgkprogamingTheme.paddingTripleExtraLarge,
    bottom: VgkprogamingTheme.paddingTripleExtraLarge,
    right: VgkprogamingTheme.paddingTripleExtraLarge,
    left: VgkprogamingTheme.paddingTripleExtraLarge,
  );

  static BorderRadius borderRadiusLow = BorderRadius.all(
    Radius.circular(8.0),
  );

  static BorderRadius borderRadiusMedium = BorderRadius.all(
    Radius.circular(16.0),
  );

  static BorderRadius borderRadiusHigh = BorderRadius.all(
    Radius.circular(32.0),
  );

  static Matrix4 transform(Animation<dynamic> mainScreenAnimation) {
    return Matrix4.translationValues(
        0.0, 20 * (1.0 - mainScreenAnimation.value), 0.0);
  }

  static Matrix4 subTransform(Animation<dynamic> mainScreenAnimation) {
    return Matrix4.translationValues(
        60 * (1.0 - mainScreenAnimation.value), 0.0, 0.0);
  }

  static SizedBox sizedBoxEmpty = SizedBox(
    height: VgkprogamingTheme.heightSpace,
  );

  static Animation animationOption(AnimationController animationController) {
    return Tween<double>(begin: 0.0, end: 1.0).animate(CurvedAnimation(
        parent: animationController,
        curve: Interval((1 / 10) * 3, 1.0, curve: Curves.fastOutSlowIn)));
  }

  static Decoration cardDecorationWithPopUp = BoxDecoration(
    boxShadow: <BoxShadow>[
      BoxShadow(
          color: VgkprogamingTheme.primaryColorDark.withOpacity(0.6),
          offset: Offset(1.1, 4.0),
          blurRadius: 8.0),
    ],
    gradient: LinearGradient(
      colors: <HexColor>[
        VgkprogamingTheme.primaryColorDark,
        VgkprogamingTheme.primaryColor,
      ],
      begin: Alignment.topLeft,
      end: Alignment.bottomRight,
    ),
    borderRadius: const BorderRadius.only(
      bottomRight: Radius.circular(8.0),
      bottomLeft: Radius.circular(8.0),
      topLeft: Radius.circular(8.0),
      topRight: Radius.circular(54.0),
    ),
  );
}

class HexColor extends Color {
  HexColor(final String hexColor) : super(_getColorFromHex(hexColor));

  static int _getColorFromHex(String hexColor) {
    hexColor = hexColor.toUpperCase().replaceAll('#', '');
    if (hexColor.length == 6) {
      hexColor = 'FF' + hexColor;
    }
    return int.parse(hexColor, radix: 16);
  }
}
